#
#  APRS4R - a ruby based aprs gateway/digipeater
#  Copyright (C) 2006 by Michael Conrad <do5mc@friggleware.de>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
#

require 'aprs4r/SocketConfiguration'
require 'aprs4r/ConfigurationAttribute'


class AX25SocketConfiguration < SocketConfiguration

  attr_reader :device, :baudrate, :mode, :call, :speed, :timeout
  attr_writer :device, :baudrate, :mode, :call, :speed, :timeout


  def to_yaml_properties
    super + %w{@device @baudrate @mode @call @speed}
  end


  def attributes
    attributes = [
                  ConfigurationAttribute.new( "device", true, 10, "string", "Ger&auml;t", 10),
                  ConfigurationAttribute.new( "baudrate", true, 11, "int", "Baudrate", 6),
                  ConfigurationAttribute.new( "mode", true, 12, "string", "Modus", 20),
                  ConfigurationAttribute.new( "call", true, 13, "string", "Rufzeichen", 10),
                  ConfigurationAttribute.new( "speed", true, 14, "int", "Geschwindigkeit", 6),
                  ConfigurationAttribute.new( "timeout", true, 15, "int", "Timeout", 6)
                 ]

    return super + attributes
  end

end
