#
#  APRS4R - a ruby based aprs gateway/digipeater
#  Copyright (C) 2007 by Michael Conrad <do5mc@friggleware.de>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
#

require 'Logger'

require 'thread'


class SocketRecvThread

  @@logger = Logger.get_logger( "SocketRecvThread");


  def initialize( socket)
    @@logger.info( "initialize( socket)")

    @socket = socket
    @name = socket.name
    @enable = socket.enable

    @queue = Queue.new

    return
  end


  def recvAPRSMessage
    @@logger.info( "recvAPRSMessage")

    return @queue.pop
  end


  def run
    @@logger.info( "run")
    
    if !@enable 
      return
    end

    while true
      
      # wait for message
      message = @socket.readAPRSMessage
      @@logger.warn( "message recv on #{@name}: #{message}")

      # queue message in recv queue
      @queue.push( message)

    end

    return
  end

  
end
